// ffmpeg incudes
#include <libavformat/avformat.h>
#include <libavcodec/avcodec.h>
#include <libavutil/avutil.h>


#include <pthread.h>
#include <pblibav.h>




int PB_AVGetAudioFrame(PBAV_FILE_INFO *PBAV)
{
    if (PBAV->Audio->AVC->Buffer == 0) return -1;

    static AVPacket CurPacket;
    static uint8_t *audio_pkt_data = NULL;
    static int audio_pkt_size      = 0;
    int len, data_size;

    for(;;)
    {
        while(audio_pkt_size > 0)
        {
            data_size = PBAV->Audio->AVC->BufferSize;

            PB_AVLockMutex(PBAV->Audio->AVC->BufferMutex);

            len = avcodec_decode_audio3(PBAV->Audio->AVC->CodecCtx, (int16_t *)PBAV->Audio->AVC->Buffer, &data_size, &CurPacket);

            PB_AVUnlockMutex(PBAV->Audio->AVC->BufferMutex);

            if(len < 0)
            {
                audio_pkt_size = 0;
                break;
            }

            audio_pkt_data += len;
            audio_pkt_size -= len;

            if(data_size <= 0) continue;

            return data_size;

        }

        if(CurPacket.data)  av_free_packet(&CurPacket);

        if (PBAV->quit) return -2;

        if(PB_AV_get_qPacket(PBAV, PBAV->Audio->Queue, &CurPacket, 1) < 0) return -1;

        audio_pkt_data = CurPacket.data;
        audio_pkt_size = CurPacket.size;
    }

    return 1;
}




