// ffmpeg incudes
#include <libavformat/avformat.h>
#include <libavcodec/avcodec.h>
#include <libavutil/avutil.h>
#include <libswscale/swscale.h>

#include <pthread.h>
#include <pblibav.h>

PBAVMutex * PB_AVCreateMutex()
{
    PBAVMutex *pbav_m;
    pbav_m = calloc(1, sizeof(PBAVMutex));

    pthread_mutex_init(&pbav_m->myMutex, NULL);
    pthread_cond_init(&pbav_m->myCondition, NULL);
    return pbav_m;
}

void PB_AVFreeMutex(PBAVMutex *pbav_m)
{
    pthread_mutex_destroy(&pbav_m->myMutex);
    pthread_cond_destroy(&pbav_m->myCondition);
}

void PB_AVLockMutex(PBAVMutex *pbav_m)
{
    pthread_mutex_lock(&pbav_m->myMutex);
}

int PB_AVTryLockMutex(PBAVMutex *pbav_m)
{
    return pthread_mutex_trylock(&pbav_m->myMutex);
}

void PB_AVUnlockMutex(PBAVMutex *pbav_m)
{
    pthread_mutex_unlock(&pbav_m->myMutex);
}

void PB_AVWaitMutex(PBAVMutex *pbav_m)
{
    pthread_cond_wait(&pbav_m->myCondition, &pbav_m->myMutex);
}

void PB_AVSignalMutex(PBAVMutex *pbav_m)
{
    pthread_cond_signal(&pbav_m->myCondition);
}

